#ifndef __Object_h__
#define __Object_h__

#include <string>
#include <stdio.h>
#include <list>
#include <vector>
#include <map>
#include <queue>
#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"
#include <ode/ode.h>

using namespace std;

#include "ObjectTypes.h"

enum {
	OBJECT_ACTION_NONE,
	OBJECT_ACTION_DELETE,
};

enum {
	COLLISION_UNHANDLED,
	COLLISION_HANDLED,
	COLLISION_HANDLED_IGNORE,
};

class Object {
public:
	Object() { deleted = false; x = y = z = theta = 0.0; }
	virtual ~Object() {}
	virtual int GetType() { return OBJECT_NONE; }
	virtual void Draw() {}
	virtual void SetupODE(dWorldID, dSpaceID) {}
	virtual void DestroyODE() {
		vector<dGeomID>::iterator it;
		for(it = geoms.begin(); it != geoms.end(); it++) { dGeomDestroy(*it); }
	}
	virtual void SetupGL() {}
	virtual void UpdatePositions() {}
	virtual int UpdatePhysics() { return OBJECT_ACTION_NONE; }
	virtual void PrepareForCollision() {}
	virtual int HandleCollision(dGeomID /*you*/, int /*wp*/, Object * /*other*/, dSurfaceParameters & /*surface*/) { return COLLISION_UNHANDLED; }
	virtual void PostCollision() {}

	vector<dGeomID> geoms;

	double x, y, z, theta;
	
	bool IsDeleted() { return deleted; }
	void SetDeleted() { deleted = true; }
	
private:
	bool deleted;
};

#endif
