#include "core.h"
#include "Wall.h"
#include "Target.h"
#include <ctype.h>

void SimCore::LoadWallsFile(string path)
{
	FILE *fp = fopen(path.c_str(), "r");
	int loaded = 0;
	if(!fp) return;

	while(!feof(fp)) {
		char s[1024];
		fgets(s, 1024, fp);
		if(feof(fp)) break;
		
		char *p = s;
		if((p = strchr(p, '#')) != NULL) *p = 0; // ignore comments
		p = s;
		if((p = strchr(p, '%')) != NULL) *p = 0; // same for %
		if(strchr(s, ',') == NULL) continue; // nothing useful on line
		
		p = s;
		double vals[9];
		for(int i=0; i<8; i++) {
			// chew beginning
			while(*p && isspace(*p)) p++;
			while(*p == ',') p++;
			while(*p && isspace(*p)) p++;

			sscanf(p, "%lf", &vals[i]);

			if(strchr(p, ',') != NULL) p = strchr(p, ',');
		}

		Wall *w = new Wall(vals[0], vals[1], vals[2], vals[3], vals[4], vals[5], vals[6], vals[7]);
		loaded++;

		objects.push_back(w);
	}

	fclose(fp);

	fprintf(stderr, "Loaded %i walls\n", loaded);
}

void SimCore::LoadTargetsFile(string path)
{
	FILE *fp = fopen(path.c_str(), "r");
	int loaded = 0;
	if(!fp) return;

	while(!feof(fp)) {
		char s[1024];
		fgets(s, 1024, fp);
		if(feof(fp)) break;

		char *p = s;
		if((p = strchr(p, '#')) != NULL) *p = 0; // ignore comments
		p = s;
		if((p = strchr(p, '%')) != NULL) *p = 0; // same for %
		if(strchr(s, ',') == NULL) continue; // nothing useful on line

		p = s;
		double vals[6];
		for(int i=0; i<6; i++) {
			while(*p && isspace(*p)) p++;
			while(*p == ',') p++;
			while(*p && isspace(*p)) p++;

			sscanf(p, "%lf", &vals[i]);

			if(strchr(p, ',') != NULL) p = strchr(p, ',');
		}

		Target *t = new Target(vals[0], vals[1], vals[2], vals[3], vals[4], vals[5]);
		loaded++;

		objects.push_back(t);
	}

	fclose(fp);

	fprintf(stderr, "Loaded %i targets\n", loaded);
}

